#include <netinet/in.h>
#include <netinet/tcp.h>
#include <caml/memory.h>

value setsockopt_int(int *sockopt, value socket, int level, value option, value status); /* from ocaml-3.08 sockopt.o */

/*
 * set TCP_NODELAY option on given socket
 */

/* set TCP_NODELAY option on given socket */
CAMLprim value stub_set_tcp_nodelay(value socket, value status)
{
  CAMLparam2(socket, status);
  int x = TCP_NODELAY; /* pass as array, get 0-nth element */
  CAMLreturn(setsockopt_int(&x, socket, IPPROTO_TCP, 0, status));
}


//and in the .mli:

//external set_tcp_nodelay : Unix.file_descr -> bool -> unit = "stub_set_tcp_nodelay"